%global gem_name uglifier
%global uglify_js_version 2.8.22
%global source_map_version 0.5.6
Name:                rubygem-%{gem_name}
Version:             3.2.0
Release:             1
Summary:             Ruby wrapper for UglifyJS JavaScript compressor
License:             MIT and BSD
URL:                 http://github.com/lautis/uglifier
Source0:             https://rubygems.org/gems/uglifier-%{version}.gem
Source1:             https://github.com/lautis/uglifier/archive/v%{version}.tar.gz
Patch1:              rubygem-uglifier-3.2.0-unbundle-js-files-for-jscript.patch
BuildRequires:       ruby(release) rubygems-devel ruby rubygem(execjs) >= 0.3.0 rubygem(rspec)
BuildRequires:       nodejs uglify-js = %{uglify_js_version}
Provides:            bundled(uglify-js) = %{uglify_js_version}
Provides:            bundled(nodejs-source-map) = %{source_map_version}
BuildArch:           noarch
%description
Uglifier minifies JavaScript files by wrapping UglifyJS to be accessible in
Ruby.

%package doc
Summary:             Documentation for %{name}
Requires:            %{name} = %{version}-%{release}
BuildArch:           noarch
%description doc
Documentation for %{name}.

%prep
gem unpack %{SOURCE0}
%setup -q -D -T -n  %{gem_name}-%{version}
gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec
%patch1 -p1
sed -i '/files/ s|"lib/es5.js".freeze, ||' %{gem_name}.gemspec
sed -i '/files/ s|"lib/split.js".freeze, ||' %{gem_name}.gemspec
rm lib/uglify.js

%build
uglifyjs --self --comments /Copyright/ > lib/uglify.js
gem build %{gem_name}.gemspec
%gem_install

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/

%check
pushd .%{gem_instdir}
tar xzf %{SOURCE1}
cd %{gem_name}-%{version}
sed -i "/require 'sourcemap'/ s/^/#/"  spec/spec_helper.rb
sed -i '/SourceMap::Map/ i \    pending' spec/source_map_spec.rb
rspec spec
popd

%files
%dir %{gem_instdir}
%exclude %{gem_instdir}/.*
%license %{gem_instdir}/LICENSE.txt
%{gem_libdir}
%exclude %{gem_instdir}/uglifier.gemspec
%exclude %{gem_cache}
%{gem_spec}

%files doc
%doc %{gem_docdir}
%doc %{gem_instdir}/CHANGELOG.md
%doc %{gem_instdir}/CONTRIBUTING.md
%{gem_instdir}/Gemfile
%doc %{gem_instdir}/README.md
%{gem_instdir}/Rakefile

%changelog
* Sat Aug 8 2020 yanan li <liyanan032@huawei.com> - 3.2.0-1
- Package init
